#include <iostream>
#include <Fl/Fl.H>
#include <Fl/Fl_Box.H>
#include <FL/Fl_Window.H>
#include <FL/fl_draw.H>
#include "vkvm.hpp"

#ifndef GUI_GUI_HPP
#define GUI_GUI_HPP
class GUI_Window : public Fl_Window {
    int x, y, button;
    int handle(int e);
public:
    GUI_Window(int x, int y, const char *l) : Fl_Window(x, y, l)
}

class Image : public Fl_Widget {
    uchar *buf;
public:
    Image(int x, int y, int w, int h);
    void refresh_image(void *pointer);
    void change_color(void *pointer);
    void refresh_statusbar(void *pointer);
    void change_status(void *pointer);
}

class Statusbar : public Fl_Box {
    char *text;
public:
    Statusbar (int x, int y, int w, int h, char *text);
    void set_text(char *text);
    void change_text();
    void refresh_label();
}

void GUI_init();
void GUI_run();

#endif //GUI_GUI_HPP
