#include "GUI.hpp"

/** GUI_Window
 * The GUI_Window-class generates a window, within the window it recognizes the curretn mouse-position.
 * It also recognizes if a button is pushed on the keyboard or the mouse. Furthermore the class depict the
 * content of the Image-class and provides functions to refresh it.
 * @param x The mouse-position on the x-axis.
 * @param y The mouse-position on the y-axis.
 * @param button The button that was pushed last.
 */

class GUI_Window : public Fl_Window {
    int x, y, button;

    /*Function to handle the input*/
    int handle(int e) {
        switch (e) {
            /*Mousebutton*/
            case FL_PUSH:
                if (Fl::event_button() == FL_LEFT_MOUSE) {
                    std::cout << "Mouse:left" << std::endl;
                } else if (Fl::event_button() == FL_RIGHT_MOUSE) {
                    std::cout << "Mouse:right" << std::endl;
                } else {
                    std::cout << "Mouse:middle" << std::endl;
                }
                return 1;
                /*Mousebutton and movement*/
            case FL_DRAG:
                x = Fl::event_x();
                y = Fl::event_y();
                std::cout << "Postion X:" << x << " Postion Y:" << y << std::endl;
                if (Fl::event_button() == FL_LEFT_MOUSE) {
                    std::cout << "Mouse:left" << std::endl;
                } else if (Fl::event_button() == FL_RIGHT_MOUSE) {
                    std::cout << "Mouse:right" << std::endl;
                } else {
                    std::cout << "Mouse:middle" << std::endl;
                }
                return 1;
                /*Mousemovement*/
            case FL_MOVE:
                x = Fl::event_x();
                y = Fl::event_y();
                std::cout << "Postion X:" << x << " Postion Y:" << y << std::endl;
                return 1;
                /*keyboardbutton*/
            case FL_KEYBOARD:
                button = Fl::event_button();
                std::cout << "Keyboard:" << (unsigned short) button << " down"<<std::endl;
                return 1;
            case FL_KEYUP:
                button = Fl::event_button();
                std::cout << "Keyboard:" << (unsigned short) button << " up"<<std::endl;
                return 1;
        }

    }

public:
    GUI_Window(int x, int y, const char *l) : Fl_Window(x, y, l) {}
};

