#include "GUI.hpp"

/** Statusbar
 *  The class inherits a char *text from the Fl_Box. It also shows the window-resolution and the mouse-position.
 *  @param text: A pointer to a char-array, that can contain a text like a status or whatever you want.
 */

class Statusbar : public Fl_Box {
    char *text;
public:
    /** The constructor of Statusbar has to get additional parameters.
      * @param x: The mouse-position on the x-axis.
      * @param y: The mouse-position on the y-axis:
      * @param w: The width of a single pixel,
      * @param h: The height of a single pixel.
      */
    Statusbar (int x, int y, int w, int h, char *text) :
            Fl_Box(x, y, w, h,text) {
        this->text = text;
    };
    void set_text(char *text) {
        this->text = text;
    }
    //An exampel to show, how the content of the text can be changed.
    void change_text(){
        if(text=="status0")
            set_text("status1");
        else
            set_text("status0");
    }
    //This function refreshes the statusbar.
    void refresh_label(){
        this->label(text);
    }
};
